'Pjec stanice by Jenda23 - autor
'
'Drobn pravy programu PaJa-trb (4-5.2010)
   'dal upravy na novou  pajku BcMP duben 2017

$regfile = "M8def.dat"                                      ' the chip we use
$crystal = 12000000                                         ' crystal oscillator value


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''                                                                                                                                   ''
''                                                                                                                                   ''
''                                                    Inicializace MCU                                                               ''
''                                                                                                                                   ''
''                                                                                                                                   ''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Config Lcd = 16 * 2                                         'Typ LCD

Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5 , E = Portc.1 , Rs = Portc.0       'Konfigurace pin LCD
Cursor Off                                                  'vypni kurzor

Config Timer2 = Pwm , Prescale = 1 , Compare Pwm = Clear Up , Pwm = On       'Timer2 jako PWM, dlika = 1, pi dosaen shody resetuj, PWM zapnuto

Config Timer1 = Timer , Prescale = 256                      'Timer1 jako timer, dlika 256

Config Spi = Soft , Din = Pind.6 , Ss = None , Clock = Portd.7       'Kobfigurace SPI, softwarov


Config Int0 = Falling                                       'Konfigurace peruen INT0, reaguj na sestupnou hranu
Config Int1 = Falling                                       'Konfigurace peruen INT1, reaguj na sestupnou hranu


Config Portd.5 = Output                                     'PortD.5 jako vstup pro CS AD pevodnku
Portd.5 = 1                                                 'zablokuj AD
Ss Alias Portd.5                                            'zstupn symbol pro portD.5

Config Portd.1 = Input                                      'smrov vstup z Rotacniho koderu

Config Portb.1 = Output                                     'podsviceni displeje
Config Portb.2 = Output                                     'port pro zelenou LED
Config Portb.3 = Output                                     'Vstup PWM - vyhrivani telesa
Config Portb.4 = Output                                     'port pro cervenou LED

Piezo Alias Portd.4                                         'piezosirenka
Zelena Alias Portb.2                                        'pojmenovani portB.2 jako zelena
Cervena Alias Portb.4
Podsviceni Alias Portb.1                                    'podsviceni LCD
Reset Piezo
Reset Zelena
Reset Cervena

'Tccr2 = &B0110_1001                                         'Timer1 jako fast PWM, prescaler=1, Clear OC2 on Compare Match, set OC2 at TOP
'Assr.3 = 1                                                  'hodiny pro timer2 z krystalu
'Timsk.7 = 1                                                 'Timer/Counter2 Output Compare Match Interrupt Enable

'OCR2= hodnota PWM

Timer1 = 30000                                              'Poten hodnota registru TCNT1

Disable Interrupts                                          'zaka vechna peruen
Enable Timer1                                               'povol timer1
Stop Timer1                                                 'zastav timer1
Enable Timer2                                               'povol timer2
Stop Timer2                                                 'zastav timer2
Enable Oc2                                                  'povol kompartor hodnoty registru TCNT2

Enable Int0                                                 'povol peruen INT0
Enable Int1                                                 'povol peruen INT1

Spiinit

On Timer1 _mod                                              'obsluha peruen od Timeru1
On Int0 Koder                                               'obsluha peruen od INT0
On Int1 Tlacitko                                            'obsluha peruen od INT1

Declare Sub Mereni()                                        'zave Podprogram "Mereni"
Declare Sub _stendby()                                      'zave podporgram "_stendby"


Deflcdchar 1 , 16 , 6 , 9 , 8 , 8 , 9 , 6 , 32              ' stupn celsia za hodnotou
Deflcdchar 2 , 14 , 14 , 14 , 14 , 31 , 31 , 31 , 14        ' teplomer_dolni_plny
Deflcdchar 3 , 4 , 10 , 10 , 10 , 14 , 14 , 14 , 14         ' teplomer_horni_pulka
Deflcdchar 4 , 10 , 10 , 10 , 10 , 17 , 17 , 17 , 14        ' teplomer_dolni_prazdny
Deflcdchar 5 , 4 , 10 , 10 , 10 , 10 , 10 , 10 , 10         ' teplomer_horni_prazdny

Dim Pwm As Byte                                             'promnn pro zpis do PWM

Dim A(2) As Byte                                            'pole hodnot (2 x 8 bit) petench z AD

Dim Hodnota As Word                                         'vsledn hodnota AD po prav

Dim Teplota As Single , Teplota2 As Word                    'promnn pro vpoet teploty

Dim Tempset As Word , Dif As Single , Difabs As Byte        ' promnn pro regulan odchylku

Dim Stav As Bit , Hodnotanast As Word , Tlac As Bit         'pomocn promnn
Dim Prvnizahrati As Bit                                     'po zapnuti muze po dosazeni teploty pipnout piezo
Dim Tempsave As Eram Word                                   'promnn pro uloen do eeprom
Dim Piezosave As Eram Byte At 2

   'po naprogramovani nastav maximalni hodnoty promenych
If Tempsave > 450 Then
   Tempsave = 450                                           'omezen maximln teploty po naprogramovani procesoru
   Piezosave = 1


End If


Tempset = Tempsave

  Prvnizahrati = 1                                          'prednastaveni pro zvukovou indikaci dosazeni teploty pri prvnim zahrati

'-----------------------------------------------------------------------------------------------------------------




Hodnotanast = Tempsave                                      'vyten poslednho nastavenho daje z EEPROM procesoru
Tempset = Tempsave

'-------------------------------------------------------------------------------
Set Podsviceni                                              'zapni podsviceni LCD


Cls                                                         'vyma displej
Locate 1 , 1                                                'na prvn dek, druh sloupec
Lcd "Mikropajka 2017"
Locate 2 , 5 : Lcd "* BcMP *"                               'na druh dek, pt sloupec
Wait 3

Cls
Locate 1 , 4
Lcd "Software"
Locate 2 , 6
Lcd "v 2.5"

Wait 1
Cls

     If Piezosave = 1 Then
   Set Piezo : Waitms 100 : Reset Piezo
End If


  Cls
Locate 1 , 1 : Lcd Chr(3) ; "  SET "                        'znak z tabulky  (teplomr)
Locate 2 , 1 : Lcd Chr(2) ; "  HROT "
Locate 1 , 16 : Lcd Chr(3)
Locate 2 , 16 : Lcd Chr(2)

Enable Interrupts                                           'povol vechna peruen
Start Timer1                                                'spus timer1
Start Timer2                                                'spus timer2 - PWM



'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''                                                                                                                                   ''
''                                                                                                                                   ''
''                                                    Hlavn program                                                                 ''
''                                                                                                                                   ''
''                                                                                                                                   ''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Do

nop

Loop

End
'opakuje nekonenou smyku a ek na peruen (od kodru, tlatka, asovae)


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''Obsluha peruen, podprogramy'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


'podprogram detekce aktivity modu stendby (peruen od timeru1 kadch cca 500ms)

_mod:                                                       'nzev podprogramu
If Tlac = 0 Then                                            'pokad je promnn 0 tak (stendby vypnuto)
Gosub Mereni                                                'pokrauj do podprogramu men teploty

Elseif Tlac = 1 Then                                        'pokad je promnn 1 (stendby zapnuto) jdi do podrogramu stendby
Gosub _stendby

End If                                                      'konec podmnky

Return                                                      'ukonen peruen


'---------------------------mereni------------------------------


Sub Mereni()                                                'podsmyka men



Timer1 = 30000                                              'nastaven registru TCNT1
Stop Timer2                                                 'zastav timer2 (vypni PWM)
Portb.3 = 0                                                 'zajist aby v kadm ppad bylo toptko odpojeno

Waitms 2                                                    'pokej na ustlen proud (death time)

Reset Ss                                                    'aktivuj AD

Spiin A(1) , 1                                              'peti prvn byte z AD (MSB)
Hodnota = A(1)                                              'zapi hodnotu do promnn (bit 0 a 7)
Hodnota = Hodnota * 256                                     'jeliko se prvn te MSB, je nutn tento byte pesunout na pozici 8 a 16
Spiin A(2) , 1                                              'peti druh byte z AD (LSB)
Hodnota = Hodnota + A(2)                                    'zapi do promnn)

Set Ss                                                      'deaktivuj AD


Ocr2 = Difabs                                               ' zapi hodnotu do registru PWM (obsah komparanho registru)
Start Timer2                                                'spus Timer2 (zapni PWM)


Shift Hodnota , Left , 2                                    'posledn dva bity jsou neplatn proto je nutn je elimonovat
Shift Hodnota , Right , 4                                   'pesun prvnho bitu na prvn pozici v promnn


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''Smrov rovnice pmky'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Teplota = Hodnota + 196.94                                  'byla urena rovnice pro pmku zvislosti teploty na napt termolnku
Teplota = Teplota * 0.21


Dif = Tempset - Teplota                                     'vpet regulan odchylky
 If Prvnizahrati = 1 Then                                   'pri prvnim zahrati
   If Dif <= 1 Then                                         'a dosazeni nastavene teploty
         Prvnizahrati = 0                                   'vynuluj priznak prvniho zahrati
         If Piezosave = 1 Then                              'a v pripade povoleni pieza 3x zapiskej
            Set Piezo : Waitms 75 : Reset Piezo : Waitms 200
            Set Piezo : Waitms 100 : Reset Piezo
         End If
   End If
End If

If Dif > 5 Then                                             'pokad je regulan odchylak vt jak 5C tak LED erven
Reset Zelena                                                'LED zelena
Set Cervena                                                 'LED cervena


Elseif Dif <= 5 Then                                        'pokud je regulan odchylak mn jak 5C tak LED zelen
Set Zelena
Reset Cervena

End If                                                      ' konec podmnky



Dif = Dif * 20                                              'strmost regulace PWM




If Dif => 0 Then                                            'pokad nen odchylka zporn (nen petopeno) tak


If Dif => 255 Then                                          'pokad je strmost vt jak 255 tak trvale top
Ocr2 = 255


Elseif Dif < 255 Then                                       'pokad je strmost men jak 255 tak reguluj pomoc PWM
Dif = Round(dif)

Difabs = Dif                                                'pevod na vhodn typ promnn

Ocr2 = Difabs                                               'zapsn vsledku do PWM registru a prava regulace

End If


Elseif Dif < 0 Then                                         'pokad je regulan odchylka zporn (petopeno) vypni topen
Difabs = 0
Ocr2 = 0

End If



Teplota = Round(teplota)                                    'zaokrouhlen vsledku men na cel sla
Teplota2 = Teplota                                          'pevod na vhodnou celoselnou promnnou


Locate 1 , 9
Lcd Tempset ; " " ; Chr(1) ; "  "                           'zobraz nastavenou teplotu

Locate 2 , 9
Lcd Teplota2 ; " " ; Chr(1) ; "  "                          'zobraz aktuln teplotu

Tempsave = Hodnotanast                                      'ulo do EEPROM (bylo by vhodn upravit aby se uloilo jen v ppad zmny)

    If Teplota > 500 Then
      Cls                                                   'kontrola pripojeni termoclanku (neboli prekroceni teploty pres 500C)
     Locate 1 , 5 : Lcd "Porucha"
     Locate 2 , 1 : Lcd "Topeni odpojeno"

     If Piezosave = 1 Then                                  'v pripade poruchy termoclanku a povoleni pieza
         Set Piezo : Waitms 500 : Reset Piezo               'zapiskej 0,5s
      End If
   End If



End Sub                                                     'konec podprogramu



'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''Obsluha modu stendby'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


'princip je stejn, zobrazovno a teplota je udrovna na 120C

Sub _stendby()

Timer1 = 30000

Stop Timer2
Portb.3 = 0

Waitms 2

Reset Ss

Spiin A(1) , 1
Hodnota = A(1)
Hodnota = Hodnota * 256
Spiin A(2) , 1
Hodnota = Hodnota + A(2)

Set Ss


Ocr2 = Difabs
Start Timer2


Shift Hodnota , Left , 2
Shift Hodnota , Right , 4

Teplota = Hodnota + 196.94
Teplota = Teplota * 0.21


Dif = Tempset - Teplota


Dif = Dif * 20


If Dif => 0 Then

If Dif => 255 Then
Ocr2 = 255

Elseif Dif < 255 Then
Dif = Round(dif)

Difabs = Dif

Ocr2 = Difabs

End If


Elseif Dif < 0 Then
Difabs = 0
Ocr2 = 0

End If


End Sub



'''''''''''''''''''''''''''''''''''''''''''''''''Obsluha rotanho koderu''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Koder:


Stav = Pind.1                                               'zjisti hodnotu smeroveho vstupu z koderu

If Stav = 1 Then                                            'pokad je smr oten vpravo tak
 Hodnotanast = Hodnotanast + 5                              'piti 5 k nastaven teplot
Elseif Stav = 0 Then                                        'pokad je smr oten vlevo tak
 Hodnotanast = Hodnotanast - 5                              'odeti 5 od nastaven teploty
End If


If Hodnotanast < 80 Then                                    'omezen minimln teploty
Hodnotanast = 80
End If

If Hodnotanast > 450 Then                                   'omezen maximln teploty
Hodnotanast = 450
End If

Tempset = Hodnotanast                                       'pepis do promnn pro men teploty

Locate 1 , 9

Lcd Tempset ; " " ; Chr(1) ; "  "                           'zobraz nastavenou teplotu


Waitms 1

Return                                                      'nvrat z peruen



'''''''''''''''''''''''''''''''''''''''''''''''''Obsluha stisku tlatka'''''''''''''''''''''''''''''''''''''''''''''''''


Tlacitko:

Toggle Tlac                                                 'tlatko bylo stisknuto neguj hodnotu pedchozho stavu promnn

If Tlac = 0 Then                                            'pokad se pechz do aktvnho modu tak

Set Podsviceni                                              'zapni podsviceni LCD

Hodnotanast = Tempsave                                      'peti hodnoty z EEPROM
Tempset = Tempsave


Gicr.6 = 1                                                  'povol extern peruen INT0

Cls                                                         'vyma LCD
Locate 1 , 1
Lcd Chr(3)                                                  'znak z tabulky 3 (teplomr)
Locate 2 , 1
Lcd Chr(2)

Locate 1 , 16
Lcd Chr(3)                                                  'znak z tabulky 3 (teplomr)
Locate 2 , 16
Lcd Chr(2)

Locate 2 , 3                                                'zobraz parametry
Lcd " HROT" ; " "

Locate 1 , 3
Lcd " SET" ; " "

Locate 1 , 9
Lcd Tempset ; " " ; Chr(1) ; "  "

Locate 2 , 9
Lcd Teplota2 ; " " ; Chr(1) ; "  "



Elseif Tlac = 1 Then                                        'pokad se pechz do stendby tak

Set Zelena
Set Cervena                                                 'zelen + erven = lut LED



Gicr.6 = 0                                                  'vypni extern peruen INT0
 Cls
   Locate 1 , 1 : Lcd Chr(5) ; "   Stand-by   " ; Chr(5)
   Locate 2 , 1 : Lcd Chr(4) ; "     120 " ; Chr(1) ; "    " ; Chr(4)

Tempset = 120                                               'nastav klidovou teplotu na 120C


End If                                                      'konec podmnky

Waitms 500                                                  'potlaen zkmit

Return                                                      'nvrat z peruen

'********************************** KONEC *************************************